//  "KP_Spline.inc" by Dave Matthews, 2005
//Array of a knot to use to fill a spline. The full array goes from 0 .. (Array_Size-1)
//This creates N_Of_Splines parallel splines 

// The below pov file is an array[Arr_Size] named KNOT.  
// It declares the following variable names:
// Arr_Size -- Number of vectors (0..Arr_Size-1)
// N_Of_Splines -- Number of edge splines in the aray (= 'nseg' in KnotPlot)
// KNOT -- an array of size Arr_Size

//////////////////////////////////////////////////////
//// Here's a sample scene, using the edge and center splines
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////  

#include "KP_Array.pov" // Need to load this first, or change it in KP_Spline.inc

#include "KP_Spline.inc" //

#include "transforms.inc"  // Used for the Spline_Trans macro, to follow a spline


#declare KFIN = finish { ambient 0.25 diffuse 0.45 brilliance 4 specular 0.3 roughness 0.000001 metallic }

#declare Frame_Knot = blob { threshold 0.5

#local Num = 90;
#local K = 0;
#while (K < Num )
#local J = 0;
#while (J < N_Of_Splines)
cylinder { KNOT_Spline[J](K/Num),KNOT_Spline[mod(J+1,N_Of_Splines)](K/Num) 0.15, 0.8 
  pigment { color rgb <0.93,0.88,0.65>  } finish {KFIN} } 
#local J = J + 1;
#end
#local K = K + 1;
#end

#local Num = 2700;
#local K = 0;
#while (K < Num ) 
#local J = 0;
#while (J < N_Of_Splines)
sphere { KNOT_Spline[J](K/Num) 0.17, 1.2 pigment { color rgb <0.8,0.85,1>  } finish {KFIN}} 
#local J = J + 1;
#end
#local K = K + 1;
#end

} 

#declare Arrows = union { 
#declare Num = 90;
#declare K = 0;
#while (K < Num ) 
cone {<0, 0, -0.2>, 0.2, <0, 0, 0.5>, 0 Spline_Trans(KNOT_SplineC, ((K+.5)/Num), y, 0.000001, 0.00001)
pigment { color rgb <1,0.77,0.67>  } finish {KFIN} }

#declare K = K + 1;
#end

}


object { Frame_Knot } //rotate 45*y rotate -40*z rotate 90*x   
object { Arrows } //rotate 45*y rotate -40*z rotate 90*x     
camera {angle 45 location 25*z look_at <0, 0, 0> right x*image_width/image_height up y}

light_source { <0, 200, 300> rgb 1 }
light_source { 300*z rgb 1 }
 
background { color rgb 0.75 }  

